#include "ot4xb.ch"
#include "Appevent.ch"
// ---------------------------------------------------------------------------
// Windows messages used in this sample
#define WM_COPYDATA                     0x004A
#define WM_CLOSE                        0x0010
#define WM_DESTROY                      0x0002
#define WM_NCDESTROY                    0x0082
// ---------------------------------------------------------------------------
#define SKYPECONTROLAPI_ATTACH_SUCCESS                0
#define SKYPECONTROLAPI_ATTACH_PENDING_AUTHORIZATION  1
#define SKYPECONTROLAPI_ATTACH_REFUSED                2
#define SKYPECONTROLAPI_ATTACH_NOT_AVAILABLE          3
#define SKYPECONTROLAPI_ATTACH_API_AVAILABLE          0x8001
// ---------------------------------------------------------------------------
static nLogRow := 0
static lSkypeFound   := .F.
static hWndSkypeSrv  := 0
static hWndSkypeCli  := 0
static hSkypeClass   := 0      
static lMsgDebug     := .F.
static lQuit         := .F.
// ---------------------------------------------------------------------------
// Skype window messages
static nMsgAttach    := NIL
static nMsgDiscover  := NIL
// ---------------------------------------------------------------------------
static init proc _startup_proc()
nMsgAttach   := RegisterWindowMessage("SkypeControlAPIAttach")
nMsgDiscover := RegisterWindowMessage("SkypeControlAPIDiscover")
return
// ---------------------------------------------------------------------------
proc main() 
local oThread  := Thread():New()
local GetList  := {}
local cCommand
local nSeconds  := Seconds()

oThread:Start({||SkypeThread()})

SetCursor(1)
Scroll(21,0,24,79)
SetPos(22,0)
?? Replicate( "=",80)        
?? "<esc> to EXIT or type Commands(#quit,#dbgon,"+;
   "#dbgoff,#connect,#disconnect)"

if !lSkypeFound
   LogOut( "Waiting for Skype .... " )
   while ( !lSkypeFound) .and. ( (Seconds() - nSeconds) < 20)
      if inkey(.5) == 27
         PostMessage( hWndSkypeCli , WM_CLOSE, 0, 0)
         QUIT
      end
   end
end
if !lSkypeFound
   LogOut( "SKYPE not found. !!!!" )
end

while !lQuit
   cCommand := Space(80) 
   @ 24, 0 GET cCommand
   if !ReadModal( GetList ) 
      lQuit := .T.
   else
      ParseCommand( AllTrim( cCommand ) )
   end
   GetList := {}
end
PostMessage( hWndSkypeCli , WM_CLOSE, 0, 0) // Kill the Skype Thread
return
// ---------------------------------------------------------------------------
function ParseCommand(cCmd)           
local pData    := 0
local pBuffer  := 0
local nLen     := 0

if "#quit" $ cCmd
   lQuit := .T.
elseif "#dbgon" $ cCmd
   LogOut( "SkypeControlAPIAttach   =" + StrTrim( nMsgAttach   ))
   LogOut( "SkypeControlAPIDiscover =" + StrTrim( nMsgDiscover )) 
   LogOut( "SkypeReceiverWindow     =" + StrTrim( hWndSkypeCli )) 
   LogOut( "SkypeWindow             =" + StrTrim( hWndSkypeSrv )) 
   LogOut( "MSG DEBUG MODE ON") 
   lMsgDebug := .T.
elseif "#dbgoff" $ cCmd
   lMsgDebug := .F.
   LogOut( "MSG DEBUG MODE OFF") 
elseif "#connect" $ cCmd
   lSkypeDiscover() 
elseif "#disconnect" $ cCmd
   hWndSkypeSrv := 0
   LogOut( "!!! Disconnected" )
elseif ( hWndSkypeSrv != 0 )
   pBuffer := _xgrab( cCmd , @nLen )
   pData   := _xgrab( 4 * 3 )
   PokeDWord( pData , 0 , 0 , nLen , pBuffer ) 
   if SendMessage( hWndSkypeSrv , WM_COPYDATA , hWndSkypeCli, pData )
      LogOut( "!!! Disconnected" )
      hWndSkypeSrv := 0
   end
   _xfree( pBuffer )
   _xfree( pData )
end
return NIL
// ---------------------------------------------------------------------------
static function lRegisterSkypeClass()
local oCls := WNDCLASS():New() // WNDCLASS gwst structure object
oCls:lpfnWndProc   := _callback_TestSkypeWndProc()
oCls:hInstance     := AppInstance()  // Instance handle of the EXE 
oCls:lpszClassName := "TestSkype" + UuidCreateStr()
hSkypeClass        := RegisterClass(oCls)
oCls:lpszClassName := NIL // free dynamic heap memory for the DYNSZ member
return (hSkypeClass != 0)
// ---------------------------------------------------------------------------
static function lCreateSkypeWindow()
hWndSkypeCli  := CreateWindowEx(0,hSkypeClass,,0xC40000)
return (hWndSkypeCli != 0)
// ---------------------------------------------------------------------------
static function lSkypeDiscover() 
return SendMessage( 0xFFFF, nMsgDiscover,hWndSkypeCli, 0)
// ---------------------------------------------------------------------------
function SkypeThread()
local cMsg := Chrr(0,32)
if ( (nMsgAttach == 0) .or. (nMsgDiscover == 0) ); return NIL ;end
if !lRegisterSkypeClass() ; return NIL ; end
if lCreateSkypeWindow()       
   if lSkypeDiscover() 
      while GetMessage(@cMsg)
         DispatchMessage(@cMsg)
      end
   else
      DestroyWindow( hWndSkypeCli )
   end
end
return NIL
// ---------------------------------------------------------------------------
function TestSkypeWndProc( hWnd , nMsg , wp , lp)     
local aData                                          
if lMsgDebug
   LogOut(cPrintf("**WMLOG**   |%u|%u|%u|%u|",hWnd,nMsg,wp,lp))
end
if ( ( nMsg == WM_COPYDATA ) .and. ( wp == hWndSkypeSrv ) )
   aData := PeekDWord( lp , 0 , 3 )
   LogOut(  "Message From Skype:" + PeekStr( aData[3] , 0 , aData[2] ) )
   return 1
elseif ( nMsg == nMsgAttach )
   lSkypeFound := .T.
   if ( lp == SKYPECONTROLAPI_ATTACH_SUCCESS )
      LogOut(  "!!! Connected; press <esc> to terminate" )
      hWndSkypeSrv := wp
   elseif ( lp == SKYPECONTROLAPI_ATTACH_PENDING_AUTHORIZATION )
      LogOut(  "!!! Pending authorization" )
   elseif ( lp == SKYPECONTROLAPI_ATTACH_REFUSED )
      LogOut(  "!!! Connection refused" )
   elseif ( lp == SKYPECONTROLAPI_ATTACH_API_AVAILABLE )
      LogOut(  "!!! Skype API not available" )
   elseif ( lp == SKYPECONTROLAPI_ATTACH_NOT_AVAILABLE )
      LogOut(  "!!! Try connect now (API available); issue #connect" )
   else
      return 0
   end
   return 1
elseif nMsg == WM_CLOSE
   PostMessage(hWnd, WM_DESTROY)
   PostMessage(hWnd, WM_NCDESTROY)
   return 1
elseif nMsg == WM_NCDESTROY
   PostQuitMessage(1)
end
return DefWindowProc(hWnd,nMsg,wp,lp) 
//-------------------------------------------------------------------------------------------------------------------------
BEGIN STRUCTURE WNDCLASS
    MEMBER UINT    style
    MEMBER LONG    lpfnWndProc
    MEMBER int     cbClsExtra
    MEMBER int     cbWndExtra
    MEMBER HANDLE  hInstance
    MEMBER HANDLE  hIcon
    MEMBER HANDLE  hCursor
    MEMBER HANDLE  hbrBackground
    MEMBER DYNSZ   lpszMenuName
    MEMBER DYNSZ   lpszClassName
END STRUCTURE
//-------------------------------------------------------------------------------------------------------------------------
static function LogOut(cStr)
local nLines := MlCount(cStr,80,1,.F.)
local n
for n := 1 to nLines
   if nLogRow > 21 
      Scroll( 0,0,21,79,4,0)
      Scroll( 18,0,21,79,0,80)
      nLogRow := 18
   end
   DispOutAt(nLogRow,0,Memoline(cStr,80,n,1,.F.),"W/N")
   nLogRow++
next
return NIL
//-------------------------------------------------------------------------------------------------------------------------
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
LRESULT DefWindowProc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam );
SYMBOL  DefWindowProcA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT ;
HWND CreateWindowEx( DWORD dwStyleEx,LPSTR cClassName,LPSTR cCaption,;
                     DWORD dwStyle,int x,int y,int cx,int cy,HWND hWndParent,;
                     HANDLE hMenu ,HANDLE hInstance ,POINTER32 lp);
DEFAULT hInstance := AppInstance() ;
SYMBOL  CreateWindowExA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT BOOL DestroyWindow( HWND hWnd )
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
LRESULT DispatchMessage( POINTER32 pMsg );
SYMBOL DispatchMessageA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
BOOL GetMessage( POINTER32 pMsg, HWND hWnd,UINT nMin,UINT nMax);
SYMBOL GetMessageA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
BOOL PostMessage( HWND hWnd, UINT nMsg, WPARAM wp, LPARAM lp);
SYMBOL PostMessageA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
BOOL SendMessage( HWND hWnd, UINT nMsg, WPARAM wp, LPARAM lp);
SYMBOL SendMessageA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT void PostQuitMessage( int nExitCode )
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
WORD RegisterClass( POINTER32 pWndClass ) ;
SYMBOL RegisterClassA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
BOOL UnregisterClass( LPSTR pClassName,HANDLE hInstance ) ;
DEFAULT hInstance := AppInstance() ;
SYMBOL UnregisterClassA
// ---------------------------------------------------------------------------
static DLL USER32 IMPORT;
UINT RegisterWindowMessage( LPSTR pMsgName );
SYMBOL RegisterWindowMessageA
// ---------------------------------------------------------------------------


   


